//------------------------------------------------------------------------------
// Testprogram for the CORE API for Triangle.DLL
// A use of Two-Dimensional Quality Mesh Generator and
// Delaunay Triangulator unde Delphi.
//------------------------------------------------------------------------------
//  TestCoreTriApi  - II/2002 TriplexWare;  written by A. Weidauer
//     http://www.weidauer@huckfinn.de; email:alex.weidauer@huckfinn.de
//------------------------------------------------------------------------------
Program TestCoreTriApi;

{$APPTYPE CONSOLE}
{$R-}

//-----------------------------------------------------------------------------
Uses
  Windows,
  SysUtils,
  UCoreTriAPI In 'UCoreTriAPI.pas';

//-----------------------------------------------------------------------------
Var
  InData: PTriangulateIO; // Data Input Record
  OutData: PTriangulateIO; // Data Output record
  VorData: PTriangulateIO; // Data Voronoi Output record
  k, m: Integer; // Iterator and Maximum;
  ch: Char;

//-----------------------------------------------------------------------------
Begin
  Writeln('----------------------------------------------------------------------');
  Writeln(' Testprogram for the CORE API for Triangle.DLL                      ');
  Writeln(' A use of Two-Dimensional Quality Mesh Generator and                ');
  Writeln(' Delaunay Triangulator unde Delphi.                                 ');
  Writeln('----------------------------------------------------------------------');
  Writeln('  TestCoreTriApi  - II/2002 TriplexWare;  written by A. Weidauer   ');
  Writeln('     http://www.weidauer@huckfinn.de; email:alex.weidauer@huckfinn.de');
  Writeln('----------------------------------------------------------------------');
  // make shure the point is the decimal separator
  DecimalSeparator := '.';
  // Define input points.
  New(InData);
  FillChar(InData^, SizeOf(InData^), #0);
  // set number of points and attributes
  InData.NumberofPoints := 10;
  InData.NumberofPointAttributes := 1;
  // fill the array with data poits
  NewRealArray(InData^.Pointlist, InData.NumberOfPoints * 2);
  SetRealArray(Indata^.PointList, 0, 0.0);
  SetRealArray(Indata^.PointList, 1, 0.0);
  SetRealArray(Indata^.PointList, 2, 1.0);
  SetRealArray(Indata^.PointList, 3, 0.0);
  SetRealArray(Indata^.PointList, 4, 1.0);
  SetRealArray(Indata^.PointList, 5, 10.0);
  SetRealArray(Indata^.PointList, 6, 0.0);
  SetRealArray(Indata^.PointList, 7, 10.0);
  SetRealArray(Indata^.PointList, 8, 10.0);
  SetRealArray(Indata^.PointList, 10, 10.0);
  SetRealArray(Indata^.PointList, 10, 10.0);
  SetRealArray(Indata^.PointList, 11, 5.0);
  SetRealArray(Indata^.PointList, 12, 4.0);
  SetRealArray(Indata^.PointList, 13, 5.0);
  SetRealArray(Indata^.PointList, 14, 4.0);
  SetRealArray(Indata^.PointList, 15, 8.0);
  SetRealArray(Indata^.PointList, 16, 7.0);
  SetRealArray(Indata^.PointList, 17, 8.0);
  SetRealArray(Indata^.PointList, 18, 1.0);
  SetRealArray(Indata^.PointList, 19, 7.0);

  // fill the array with data attributes
  NewRealArray(InData^.PointAttributeList,
    InData.Numberofpoints * InData.NumberOfpointAttributes);
  SetRealArray(InData^.PointAttributeList, 0, 0.0);
  SetRealArray(InData^.PointAttributeList, 1, 1.0);
  SetRealArray(InData^.PointAttributeList, 2, 2.0);
  SetRealArray(InData^.PointAttributeList, 3, 4.0);
  SetRealArray(InData^.PointAttributeList, 4, 5.0);
  SetRealArray(InData^.PointAttributeList, 5, 6.0);
  SetRealArray(InData^.PointAttributeList, 6, 7.0);
  SetRealArray(InData^.PointAttributeList, 7, 8.0);
  SetRealArray(InData^.PointAttributeList, 8, 9.0);
  SetRealArray(InData^.PointAttributeList, 9, 10.0);

  // fill the array with pointmarkers
  NewIntegerArray(InData^.PointMarkerList, InData.NumberOfPoints);
  SetIntegerArray(InData^.PointMarkerList, 0, 1);
  SetIntegerArray(InData^.PointMarkerList, 1, 2);
  SetIntegerArray(InData^.PointMarkerList, 2, 2);
  SetIntegerArray(InData^.PointMarkerList, 3, 3);
  SetIntegerArray(InData^.PointMarkerList, 4, 4);
  SetIntegerArray(InData^.PointMarkerList, 5, 4);
  SetIntegerArray(InData^.PointMarkerList, 6, 5);
  SetIntegerArray(InData^.PointMarkerList, 7, 5);
  SetIntegerArray(InData^.PointMarkerList, 8, 5);
  SetIntegerArray(InData^.PointMarkerList, 9, 5);

  InData.NumberofSegments := 0;
  InData.NumberofHoles := 0;
  InData.NumberofRegions := 1;

  // make area constraint data
  NewRealArray(InData^.RegionList, InData.NumberofRegions * 4);
  SetRealArray(InData^.RegionList, 0, 0.5);
  SetRealArray(InData^.RegionList, 1, 5.0);
  SetRealArray(InData^.RegionList, 2, 7.0);
  SetRealArray(InData^.RegionList, 3, 0.1);

  Writeln;
  Write(' How many test loops you want <integer>?'); Readln(m);

  Write('Display the results <y/n>?'); Readln(ch);
  If Not ((ch = 'y') Or (ch = 'n')) Then Begin
    Writeln(' wrong selection setting value to <n>');
    ch := 'n';
  End;

  Writeln(' --- Your input point --------------------------------');
  Report(InData^, True, False, False, False, False, False);
  _openiobuffer(80, 80);
  // testing memory leaks
  Writeln;
  For k := 1 To m Do Begin
    If ch = 'y' Then Begin
      Writeln(' --- Iteration ', k, ' of ', m,
        ' --------------------------------------');
      Writeln;
    End;
    New(OutData);
    New(VorData);
    _InitTriangleIO(OutData);
    _InitTriangleIO(VorData);
    ExecTriangulate('pczAevn', InData, OutData, VorData);
    If ch = 'y' Then Begin
      WriteStringsIO;
      Writeln(' --- Output ------------------------------------------------');
    End Else Begin
      If k Mod 100 = 0 Then write(' ', k);
      If k Mod 1000 = 0 Then writeln;
    End;
    Report(OutData^, True, True, True, True, True, True);
    Dispose(OutData);
    Dispose(VorData);
  End;
  _freeiobuffer;
  _dlpFreeTriangleIO(InData);
  Write('Press ENTER'); Readln;
  Writeln('---------------------------------------------------------------------');
  Writeln('READY');
  Writeln('---------------------------------------------------------------------');
End.

